//
//  Ball.m
//  Casse
//
//  Created by Yeolcoatl on 1/15/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import "Ball.h"


@implementation Ball

-(id)init
{
	if (self = [super init]) {
		NSRect l = {{198,150},{4,4}};
		location = l;
		xv = -1;
		yv = -2;
		speedMod=1.0;
	}
	return self;
}

-(void) moveBall 
{
	NSRect newRect = {{location.origin.x + (xv * speedMod), location.origin.y + (yv * speedMod)}, {location.size.width, location.size.height}};
	location = newRect;
	if ((location.origin.x < 1) || ((location.origin.x + location.size.width) > 399)){
		xv = -1 * xv;
	}
	
	if ((location.origin.y + location.size.height) > 399) {
		yv = -1 * yv;
	}
}

-(void) collideWithPaddleAt:(int)dFromCenter
{
	if ((dFromCenter > -4) && (dFromCenter < 4)) {
		[self setXV:0];
		[self setYV:5];
	} 
	if ((dFromCenter <= -4) && (dFromCenter > -15)) {
		[self setXV:-1];
		[self setYV:5];
	} 
	
	if ((dFromCenter >= 4) && (dFromCenter < 15)) {
		[self setXV:1];
		[self setYV:5];
	}
	if ((dFromCenter <= -15) && (dFromCenter > -25)) {
		[self setXV:-3];
		[self setYV:4];
	} 
	
	if ((dFromCenter >= 15) && (dFromCenter < 25)) {
		[self setXV:3];
		[self setYV:4];
	}
	
	if ((dFromCenter <= -25) && (dFromCenter > -35)) {
		[self setXV:-5];
		[self setYV:3];
	} 
	if ((dFromCenter >= 25) && (dFromCenter < 35)) {
		[self setXV:5];
		[self setYV:3];
	}
	
	if ((dFromCenter <= -35) && (dFromCenter > -39)) {
		[self setXV:-6];
		[self setYV:2];
	} 
	if ((dFromCenter >= 35) && (dFromCenter < 39)) {
		[self setXV:6];
		[self setYV:2];
	}
	
	if ((dFromCenter <= -39) && (dFromCenter > -41)) {
		[self setXV:0];
		[self setYV:0];
	} 
	if ((dFromCenter >= 39) && (dFromCenter < 40)) {
		[self setXV:0];
		[self setYV:0];
	}
}

-(void) setXV:(int)v
{
	xv =v;
}
-(void) setYV:(int)v
{
	yv =v;
}
-(NSRect)location
{
	return location;
}
-(void) setLocation:(NSRect)rect
{
	location = rect;
}
-(void) drawBall
{
	[[NSColor blackColor] set];
	[NSBezierPath fillRect:location];

}
-(int) x {
	return floor(location.origin.x);
}
-(int) y {
	return floor(location.origin.y);
}

- (void) collideWithBrickType:(int)type
{
	if ((type ==1) || (type ==2) || (type == 4) || (type == 5)) {
		yv = -1* yv;
	}
	
	if ((type == 3) || (type == 4) || (type == 5)) {
		xv = -1 * xv;
	}
	
	if (type == 6) {
		xv = -2;
	}
	if (type == 7) {
		yv = 2;
	}
	if (type == 8) {
		xv = 2;
	}
	if (type == 9) {
		yv = -2;
	}
	
}


@end
