//
//  CasseView.m
//  CasseEdit
//
//  Created by Yeolcoatl on 1/14/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import "CasseView.h"
#import "SaveBrick.h"
#import "MyDocument.h"

@implementation CasseView

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
    }
    return self;
}

- (void)drawRect:(NSRect)rect {
    // Drawing code here.
	int i;
	SaveBrick *brick;
	NSRect brickRect;
	
	srandom(time(NULL));
	currentLevel = [document currentLevel];
	
	for(i=0;i<[currentLevel count];i++){
		brick = [currentLevel objectAtIndex:i];
		brickRect = NSMakeRect([brick x] * 40, [brick y] * 20,40,20);
		if (NSIntersectsRect(rect,brickRect)) {
			[brick drawBrick];
		}
	}
}

- (void) mouseDown:(NSEvent *)event
{
	int x;
	int y;
	NSPoint downPoint;
	NSPoint p=[event locationInWindow];
	downPoint = [self convertPoint:p fromView:nil];
	x = floor(downPoint.x/40);
	y = floor(downPoint.y/20);
	NSLog(@"mouseDown: %d, %d",x, y);
	[document addBrickAtX:x Y:y];
	[self setNeedsDisplay:YES];

}



@end
