//
//  MyDocument.h
//  CasseEdit
//
//  Created by Yeolcoatl on 1/14/06.
//  Copyright __MyCompanyName__ 2006 . All rights reserved.
//


#import <Cocoa/Cocoa.h>

@interface MyDocument : NSDocument
{
	IBOutlet id textOut;
	IBOutlet id livesText;
	IBOutlet id view;
	NSMutableArray *levels;
	int level;
	int brickType;
	
	IBOutlet id nextButton;
	IBOutlet id prevButton;
	IBOutlet id w;
	
	int lives;
}

- (IBAction) nextLevel:(id)sender;
- (IBAction) prevLevel:(id)sender;

-(void) addBrickAtX:(int)x Y:(int)y;
- (id)currentLevel;

- (void) updateLevel;
- (void) updateUI;

-(void) setEvent;
-(int)lives;
-(void)setLives:(int)l;
@end
