//
//  SaveBrick.m
//  CasseEdit
//
//  Created by Yeolcoatl on 1/14/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import "SaveBrick.h"
#import "CasseView.h"

@implementation SaveBrick

-(void)setType:(int)t
{
	type=t;
}
-(int)type
{
	return type;
}

-(void)setX:(int)xloc
{
	x=xloc;
}
-(void)setY:(int)yloc
{
	y=yloc;
}
-(int)x
{
	return x;
}
-(int)y
{
	return y;
}
-(id)initWithX:(int)xloc Y:(int)yloc Type:(int)t
{
	if (self = [super init]) {
		[self setX:xloc];
		[self setY:yloc];
		[self setType:t];
	}
	return self;
}
-(id)init
{
	return [self initWithX:0 Y:0 Type:0];
}

- (void)encodeWithCoder:(NSCoder *)coder
{
	[coder encodeValueOfObjCType:@encode(int) at:&x];
	[coder encodeValueOfObjCType:@encode(int) at:&y];
	[coder encodeValueOfObjCType:@encode(int) at:&type];
}
- (id) initWithCoder:(NSCoder *)coder
{
	if (self = [super init]) {
		[coder decodeValueOfObjCType:@encode(int) at:&x];
		[coder decodeValueOfObjCType:@encode(int) at:&y];
		[coder decodeValueOfObjCType:@encode(int) at:&type];
	}
	return self;
}

- (void) drawBrick
{
	NSRect theRect = {{x*40, y*20},{40,20}};

	if (type == 0) {[[NSColor whiteColor] set];}
	if (type == 1) {[[NSColor magentaColor] set];}
	if (type == 2) {[[NSColor greenColor] set];}
	if (type == 3) {[[NSColor yellowColor] set];}
	if (type == 4) {[[NSColor blackColor] set];}
	if (type == 5) {[[NSColor grayColor] set];}
	if (type == 6) {[[NSColor cyanColor] set];}
	if (type == 7) {[[NSColor redColor] set];}
	if (type == 8) {[[NSColor blueColor] set];}
	if (type == 9) {[[NSColor orangeColor] set];}
	
	[NSBezierPath fillRect:theRect];
}


@end
