//
//  MyDocument.h
//  CasseEdit
//
//  Created by Yeolcoatl on 1/14/06.
//  Copyright __MyCompanyName__ 2006 . All rights reserved.
//


#import <Cocoa/Cocoa.h>

@interface MyDocument : NSDocument
{
	IBOutlet id textOut;
	IBOutlet id view;
	IBOutlet id brickSelector;
	NSMutableArray *levels;
	int level;
	int brickType;
	
	IBOutlet id newButton;
	IBOutlet id deleteButton;
	IBOutlet id nextButton;
	IBOutlet id prevButton;
}

- (IBAction) newLevel:(id)sender;
- (IBAction) deleteLevel:(id)sender;
- (IBAction) changeBrick:(id)sender;
- (IBAction) nextLevel:(id)sender;
- (IBAction) prevLevel:(id)sender;

-(void) addBrickAtX:(int)x Y:(int)y;
- (id)currentLevel;

- (void) createNewLevel;
- (void) updateLevel;
- (void) updateUI;
@end
